#! /bin/sh
set -e

# /etc/init.d/startext: start a script if found on the external SD card
# N.B. This can be used to start a user application during the
# boot process but this application must be able to run as a daemon
# otherwise it will block other boot scripts that are scheduled
# to be started later.
# Here is a definition: http://www.linfo.org/daemon.html
# Here is a tutorial: http://www.netzmafia.de/skripten/unix/linux-daemon-howto.html
# Here is a man page: http://linux.die.net/man/3/daemon

# Author: GRA <info@matrix-vision.de>
#

PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC="Start a script if found on the external SD card"
NAME=startext
DAEMON1=/media/mmcblk1/$NAME
DAEMON2=/media/mmcblk1p1/$NAME
DAEMON3=/media/mmcblk1p2/$NAME
DAEMON_ARGS="--options args"
PIDFILE=/var/run/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME

# Exit if the script is not found on the card (no partitions, partition 1 or partition 2) 
[ -x "$DAEMON1" ] || [ -x "$DAEMON2" ] || [ -x "$DAEMON3" ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

#
# Function that starts the daemon/service
#
do_start()
{
	# Return
	#   0 if daemon has been started
	#   1 if daemon was already running
	#   2 if daemon could not be started

	# choose which script to use - search on card with no partition, on partition 1 or on partition 2
	if [ -x "$DAEMON1" ]; then
		DAEMON=$DAEMON1
	elif [ -x "$DAEMON2" ]; then
		DAEMON=$DAEMON2
	elif [ -x "$DAEMON3" ]; then
		DAEMON=$DAEMON3
	fi

	start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
		|| return 1
	start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
		$DAEMON_ARGS \
		|| return 2
	# Add code here, if necessary, that waits for the process to be ready
	# to handle requests from services started subsequently which depend
	# on this one.  As a last resort, sleep for some time.
}

#
# Function that stops the daemon/service
#
do_stop()
{
	# Return
	#   0 if daemon has been stopped
	#   1 if daemon was already stopped
	#   2 if daemon could not be stopped
	#   other if a failure occurred
	start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
	RETVAL="$?"
	[ "$RETVAL" = 2 ] && return 2
	# Wait for children to finish too if this is a daemon that forks
	# and if the daemon is only ever run from this initscript.
	# If the above conditions are not satisfied then add some other code
	# that waits for the process to drop all resources that could be
	# needed by services started subsequently.  A last resort is to
	# sleep for some time.
	start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
	[ "$?" = 2 ] && return 2
	# Many daemons don't delete their pidfiles when they exit.
	rm -f $PIDFILE
	return "$RETVAL"
}

case "$1" in
  start)
	[ "$VERBOSE" != no ] && echo "Starting $DESC" "$NAME"
	do_start
	case "$?" in
		0|1) [ "$VERBOSE" != no ] && echo " OK" ;;
		2) [ "$VERBOSE" != no ] && echo " FAILED" ;;
	esac
	;;
  stop)
	echo "stop: nothing to do"
	;;
#	[ "$VERBOSE" != no ] && echo "Stopping $DESC" "$NAME"
#	do_stop
#	case "$?" in
#		0|1) [ "$VERBOSE" != no ] && echo " OK" ;;
#		2) [ "$VERBOSE" != no ] && echo " FAILED" ;;
#	esac
#	;;
  *)
	echo "Usage: $SCRIPTNAME {start}" >&2
	exit 3
	;;
esac

:
